#include <windows.h>
#include "Rar.h"

HINSTANCE Rar_HDLL;
int Rar_Initialised;

HANDLE (PASCAL *RAROpenArchive) (struct RAROpenArchiveData *ArchiveData);
HANDLE (PASCAL *RAROpenArchiveEx) (struct RAROpenArchiveDataEx *ArchiveData);
int    (PASCAL *RARCloseArchive) (HANDLE hArcData);
int    (PASCAL *RARReadHeader) (HANDLE hArcData,struct RARHeaderData *HeaderData);
int    (PASCAL *RARReadHeaderEx) (HANDLE hArcData,struct RARHeaderDataEx *HeaderData);
int    (PASCAL *RARProcessFile) (HANDLE hArcData,int Operation,char *DestPath,char *DestName);
int    (PASCAL *RARProcessFileW) (HANDLE hArcData,int Operation,wchar_t *DestPath,wchar_t *DestName);
void   (PASCAL *RARSetCallback) (HANDLE hArcData,UNRARCALLBACK Callback,LONG UserData);
void   (PASCAL *RARSetChangeVolProc) (HANDLE hArcData,CHANGEVOLPROC ChangeVolProc);
void   (PASCAL *RARSetProcessDataProc) (HANDLE hArcData,PROCESSDATAPROC ProcessDataProc);
void   (PASCAL *RARSetPassword) (HANDLE hArcData,char *Password);
int    (PASCAL *RARGetDllVersion) ();

int Init_Rar(void)
{
	Rar_HDLL = LoadLibrary("unrar.dll");

	if (Rar_HDLL != NULL)
	{
		RAROpenArchive = (HANDLE (PASCAL *)(struct RAROpenArchiveData *ArchiveData)) GetProcAddress(Rar_HDLL, "RAROpenArchive");
		RAROpenArchiveEx = (HANDLE (PASCAL *)(struct RAROpenArchiveDataEx *ArchiveData)) GetProcAddress(Rar_HDLL, "RAROpenArchiveEx");
		RARCloseArchive = (int (PASCAL *)(HANDLE hArcData)) GetProcAddress(Rar_HDLL, "RARCloseArchive");
		RARReadHeader = (int (PASCAL *)(HANDLE hArcData,struct RARHeaderData *HeaderData)) GetProcAddress(Rar_HDLL, "RARReadHeader");
		RARReadHeaderEx = (int (PASCAL *)(HANDLE hArcData,struct RARHeaderDataEx *HeaderData)) GetProcAddress(Rar_HDLL, "RARReadHeaderEx");
		RARProcessFile = (int (PASCAL *)(HANDLE hArcData,int Operation,char *DestPath,char *DestName)) GetProcAddress(Rar_HDLL, "RARProcessFile");
		RARProcessFileW = (int (PASCAL *)(HANDLE hArcData,int Operation,wchar_t *DestPath,wchar_t *DestName)) GetProcAddress(Rar_HDLL, "RARProcessFileW");
		RARSetCallback = (void (PASCAL *)(HANDLE hArcData,UNRARCALLBACK Callback,LONG UserData)) GetProcAddress(Rar_HDLL, "RARSetCallback");
		RARSetChangeVolProc = (void (PASCAL *)(HANDLE hArcData,CHANGEVOLPROC ChangeVolProc)) GetProcAddress(Rar_HDLL, "RARSetChangeVolProc");
		RARSetProcessDataProc = (void (PASCAL *)(HANDLE hArcData,PROCESSDATAPROC ProcessDataProc)) GetProcAddress(Rar_HDLL, "RARSetProcessDataProc");
		RARSetPassword = (void (PASCAL *)(HANDLE hArcData,char *Password)) GetProcAddress(Rar_HDLL, "RARSetPassword");
		RARGetDllVersion = (int (PASCAL *)()) GetProcAddress(Rar_HDLL, "RARGetDllVersion");

		if ((RAROpenArchive != NULL) && (RAROpenArchiveEx != NULL) && (RARCloseArchive != NULL) &&
			(RARReadHeader != NULL) && (RARReadHeaderEx != NULL) && (RARProcessFile != NULL) &&
			(RARProcessFileW != NULL) && (RARSetCallback != NULL) && (RARSetChangeVolProc != NULL) &&
			(RARSetProcessDataProc != NULL) && (RARSetPassword != NULL) && (RARGetDllVersion != NULL))
		{			
			Rar_Initialised = 1;
			return 0;
		}

		FreeLibrary(Rar_HDLL);
	}

	Rar_Initialised = 0;
	return 1;
}


void End_Rar(void)
{
	if (Rar_Initialised)
	{
		FreeLibrary(Rar_HDLL);
	}
}
